cimport numpy as np_


ctypedef np_.float64_t real_pix_v_t
#ctypedef np_.ndarray[real_pix_v_t, ndim=3] real_img_t


#cpdef tuple FrangiEnhancement(
#    np_.ndarray[real_pix_v_t, ndim=2] img,
#    tuple scale_range,
#    double scale_step = *,
#    double alpha = *,
#    double beta = *,
#    double frangi_c = *,
#    bint bright_on_dark = *,
#    bint in_parallel = *
#)


cdef np_.ndarray[real_pix_v_t, ndim=3] FrangiEnhancementOneScale(
    np_.ndarray[real_pix_v_t, ndim=3] img,
    double scale,
    double alpha = *,
    double beta = *,
    double frangi_c = *,
    bint bright_on_dark = *,
    object shared_enhanced = *
)


#cdef tuple[np_.ndarray[real_pix_v_t, ndim=3],np_.ndarray[real_pix_v_t, ndim=3],np_.ndarray[real_pix_v_t, ndim=3],np_.ndarray[real_pix_v_t, ndim=3],np_.ndarray[real_pix_v_t, ndim=3],np_.ndarray[real_pix_v_t, ndim=3]] HessianMatrix(
#    np_.ndarray[real_pix_v_t, ndim=3] img, double scale
#)


#cdef tuple[np_.ndarray[real_pix_v_t, ndim=3],np_.ndarray[real_pix_v_t, ndim=3],np_.ndarray[real_pix_v_t, ndim=3]] EigenValues(
#    np_.ndarray[real_pix_v_t, ndim=3] Dxx, np_.ndarray[real_pix_v_t, ndim=3] Dxy, np_.ndarray[real_pix_v_t, ndim=3] Dxz, np_.ndarray[real_pix_v_t, ndim=3] Dyy, np_.ndarray[real_pix_v_t, ndim=3] Dyz, np_.ndarray[real_pix_v_t, ndim=3] Dzz
#)


cdef np_.ndarray[real_pix_v_t, ndim=3] SortedByAbsValues(np_.ndarray[real_pix_v_t, ndim=3] array, int axis = *)


cdef np_.ndarray[real_pix_v_t, ndim=3] CarefullDivision(np_.ndarray[real_pix_v_t, ndim=3] array_1, np_.ndarray[real_pix_v_t, ndim=3] array_2)
