# Copyright CNRS/Inria/UNS
# Contributor(s): Eric Debreuve (since 2019)
#
# eric.debreuve@cnrs.fr
#
# This software is governed by the CeCILL  license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".
#
# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.
#
# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.
#
# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.

import skimage.morphology as mp_


data_path = "./data/DIO_6H_6_1.70bis_2.2_3.tif"
with_plot = False

soma_low_c = 0.15
soma_high_c = 0.7126
ext_low_c = 0.2  # 0.02  # 0.2  # ext_low_c = 9.0e-4
ext_high_c = 0.6  # 0.04  # 0.6  # high_ext = 8.0e-3

soma_selem_c = mp_.disk(2)

max_straight_sq_dist_c = 30 ** 2
max_weighted_length_c = 20.0

min_area_c = 1000

in_parallel = False
